// 3d raster vs z-level

scale = 1.0;

inch = scale * 25.4;

//stock_width = 3.75 * inch;  // 95.25
//stock_height = 7.75 * inch;
//stock_depth = 2.25 * inch;

stock_width = 3.05 * inch;  // 95.25
stock_height = 7 * inch;
stock_depth = 1.538 * inch;


// stock_width = (3.75 - 0.3) * inch;

// 102.87 mm appearance
// vs 95.25 desired

//wall_thickness = 0.3 * inch;
// wall_thickness = 0.3 * inch; 
// floor_thickness = 0.6 * inch;

// post apocalyptic, collet-avoiding coordinates
// wall_thickness = 0.3 * inch; 

margin = 0.10 * stock_width;
//margin = 0.18 * stock_width;
key_radius = 0.2 * inch;
key_height = 7; // was floor_thickness

collet_height = 20;

floor_thickness = stock_depth-7.5; // 20mm collet
floor_thickness = stock_depth-20; // 20mm collet

//floor_thickness = stock_depth- (20-key_height);

wall_thickness = 0.25 * inch; 
pumpkin_radius = stock_depth*0.5;
pumpkin_radius = stock_depth*0.33;
pumpkin_radius = stock_depth-floor_thickness;

mill_critical_angle = 30;

// pumpkin_radius = stock_width*0.18;
//pumpkin_radius = stock_width*0.18;
//pumpkin_radius = stock_depth*0.55;
//pumpkin_radius = stock_depth*0.58;

// STOCK
module stock(center=true) {
    cube(center=center, size=[stock_width, stock_height, stock_depth]);
}



//$fa=0.01;
$fa = 6;
module pumpkinoid(radius) {
    g = 0; // squatness parameter
    h = 0.8; // pumpkinoid slice depth
    slices = 8;
    
   union() {
    for(i=[1:slices]) {
        rotate([0,0,360/slices*i]) scale([1+g,h,1]) sphere(r=radius);
    }
    }
    
   
}

module end_mill() {
    mill_diameter = 1/8 * inch;
    mill_length = 8;
    collet_diameter = 16;
    
    translate([0,0,10]) union(){
    % translate([0,0,mill_length/2]) cylinder(h=mill_length,d=mill_diameter);
    % translate([0,0,mill_length*1.5]) cylinder(h = 100, d=collet_diameter);
    % translate([0,0,mill_length/2]) color("red") cylinder(h=0.1,d=mill_diameter);
    }
}

// translate([33,0,-8]) end_mill();

// translate([38,0,-9+7]) end_mill();
// translate([-18,-20,-12+7]) end_mill();
//translate([-3,0,-9+7]) end_mill();

module standard_pumpkinoid() {
    
    rotate([0,180,0]) 
    intersection() {
    union() {
    translate([0,0,-stock_width*(0.015+0.03)/2]) 
    union() {
    pumpkinoid(radius=pumpkin_radius);    
    translate([0,0,pumpkin_radius/2]) pumpkinoid(radius=pumpkin_radius*2/3);    
    }
    }
    // flat surface
    translate([0,0,pumpkin_radius*0.025]) cube(pumpkin_radius*2.25,center=true);
}
}

//pumpkinoid(stock_width);
//standard_pumpkinoid();

//key_radius = 0.4 * inch;


* translate([0,0,60]) keyed_floor(size=[stock_width,stock_height,floor_thickness], key_height=key_height);





module standard_ridge(size, slope_angle=mill_critical_angle, center=false, handedness = 1) {
    cube(size, center=center);
    //stairstepped(size, slope_angle=slope_angle, center=center, handedness =handedness);
    // ramptangle(size, slope_angle=slope_angle, center=center, handedness =handedness);
}

module stairstepped(size, slope_angle=mill_critical_angle, center=false, handedness=1) {
    stepdown = 1;
    
     
    is_major_x = (size[0] > size[1]);
    toward_middle = handedness * (is_major_x ? [0,1,0] : [1,0,0]);
    
    
    module step(n=0) {
        cube(size, center=center);
        if(n > 0) {
            translate(toward_middle*stepdown/tan(slope_angle)+[0,0,-1]*stepdown)
            step(n-1);
        }
    }
    
    //cube(size,center=center);
    step(3);
}


module ramptangle(size, slope_angle=mill_critical_angle, center=false, handedness = 1) {
    cube(size,center=center);
    
    ramp_height = size[2] - floor_thickness;
    ramp_width = size[2]/tan(slope_angle);
    
 
    is_major_x = (size[0] > size[1]);
    
    toward_middle = handedness * (is_major_x ? [0,1,0] : [1,0,0]);
    

    x = size[0]/2 - wall_thickness;
    y = size[1]/2 - wall_thickness;
    z = size[2]/2;
    z2 = size[2]/2;
    
    y2 = size[1]/2;
    
    translate([0,0,0])
    if(is_major_x) {
    translate([0,handedness*wall_thickness,0])  scale([handedness,handedness,1]) polyhedron(points=[
        [x,y,z],
        [x,y,-z2],
        [-x,y,-z2],
        [-x,y,z],
    
        [-x,y+ramp_width,-z2],
        [x,y+ramp_width,-z2],
    ], faces = [[0,1,2,3], [4,5,0,3],[4,5,1,2],[2,3,4],[0,1,5]]);
    }
    
    else {
        translate([handedness*wall_thickness,0,0])  scale([handedness,handedness,1]) polyhedron(points=[
        [x,y2,z],
        [x,y2,-z2],
        [x,-y2,-z2],
        [x,-y2,z],
    
        [x+ramp_width,-y2,-z2],
        [x+ramp_width,y2,-z2],
    ], faces = [[0,1,2,3], [4,5,0,3],[4,5,1,2],[2,3,4],[0,1,5]]);
        
    }
    
}

module keyed_floor(size=[1,1,1],inset=true,margin=0, ambidextrous_keys=false, key_height=key_height) {
    
    // [ -18.12, -19.21, 81.33 ]
    module keys(xs=[-1,1],ys=[-1,1],inset=inset) {
    for(x=xs) {
        for(y=ys) {
            color("cyan") 
            translate([x*(size[0]/2-key_radius-margin),
                       y*(size[1]/2-key_radius-margin),
                       size[2]/2])
            cylinder(h=key_height,
            r1=inset ? key_radius*0.6 : key_radius,
            r2=!inset ? key_radius*0.6 : key_radius, center=true);
            //sphere(r=key_radius);
        }}
    }
    
    if(ambidextrous_keys){
     
    difference() {
    union() {
        cube(size=size, center=true);
        keys(ys=[-1],inset=false);
        }
        keys(ys=[1], inset=true);
    }   
    }
    else{
    
    difference() {
    union() {
        cube(size=size, center=true);
        if(inset==false) keys();
        }
    if(inset==true) keys();
    }
    }
}

module four_keys(taller=false) {
    key_height=30;
    for(x=[-1,1]) {
        for(y=[-1,1]) {
            color("cyan") 
            translate([x*(stock_width/2-key_radius),
                       y*(stock_height/4-key_radius),
                       floor_thickness])
            * cylinder(h=key_height,r=key_radius);
            
//            translate([x*(stock_width/2-wall_thickness/2),
//                       y*(stock_height/4-wall_thickness),-floor_thickness*1])
//            cylinder(r=key_radius, h = key_depth*2*(taller ? 1.6 : 1), center=true);
        }
    }
}


if(0) {

rotate([0,0,90])
union () {
    % stock();

intersection() {
    //stock();
    union() {
for(polarity=[-1,1]) {
    // TOP CAP polarity= +1
    // BOTTOM CAP polarity = -1
    
    

    
    translate([0,polarity*stock_height/4,-stock_depth/4]) 
    translate([0,0,stock_depth/4]) {
    // THE ENCASEMENT
 
    union() {
    //floor for each side
    //difference() { // subtract keys on one side
    translate([0,wall_thickness/4*-polarity,-stock_depth/2+floor_thickness/2]) 
    
    // OLD FLOOR    
    // cube(center=true,[stock_width,stock_height/2,floor_thickness]);
    // NEW FLOOR
    keyed_floor(size=[stock_width-wall_thickness,stock_height/2-wall_thickness,floor_thickness], key_height=key_height, inset=polarity==1, margin=0.02*stock_width, ambidextrous_keys=false);
        
        
    
    // wall for narrow outer side
    translate([0,polarity*(stock_height/4-wall_thickness/2),0]) {
    cube([stock_width,wall_thickness,stock_depth],center=true);
    }
    
    // wall for inner divider
    translate([0,-polarity*(stock_height/4),0]) {
    cube([stock_width,wall_thickness,stock_depth],center=true);
    }
    
    // walls for long outer side
    translate([stock_width/2-wall_thickness/2,0,0])
    cube([wall_thickness,stock_height/2,stock_depth],center=true);
    translate([-(stock_width/2-wall_thickness/2),0,0])
    cube([wall_thickness,stock_height/2,stock_depth],center=true);
    
    if(polarity==1) {
           four_keys(taller=true); // positive keys
    }
    
    }   
 
 
    
        
        // OLD VERSION
//    * difference() {
//    union() {
//         difference() {
//            cube(center=true, [stock_width,stock_height/2, stock_depth]);
//             translate([0,0,floor_thickness+0*stock_depth/2]) cube(center=true, [stock_width-2*wall_thickness,stock_height/2-2*wall_thickness,stock_depth]);
//            
//        }
//        if(polarity == 1) {
//        four_keys();
//        }
//    }
//
//    }
        
//        
    // THE PUMPKINOID
    translate([0,-6*scale*polarity,-(stock_depth/2-floor_thickness)])
    rotate([0,90*(1-polarity),0]) intersection() {
    translate([0,0,polarity*stock_depth/2]) cube(center=true,[stock_width,stock_height/2,stock_depth]);
    standard_pumpkinoid();
    }
    
    }
    
}

    // (POSITIVE) SPIGOT / SPRUE
    spout_radius = 0.3 * inch;
    spout_length = stock_height/4;
    color("cyan") translate([0,-(stock_height/4)-(stock_height/4-wall_thickness/2)/2,0]) rotate([90,0,0]) cylinder(center=true,h=spout_length, r1=spout_radius,r2=spout_radius*1.5); 

}
}
}
}




// TAKE TWO: SYMMETRIC

module ambidextrous_pumpkinoid() {
rotate([0,0,90])
union () {
    * stock();

intersection() {
    //stock();
    union() {
for(polarity=[-1]) {
    // TOP CAP polarity= +1
    // BOTTOM CAP polarity = -1
    
    

    
    translate([0,polarity*stock_height/4,-stock_depth/4]) 
    translate([0,0,stock_depth/4]) {
    // THE ENCASEMENT
 
    union() {
    //floor for each side
    //difference() { // subtract keys on one side
    translate([0,wall_thickness/4*-polarity,-stock_depth/2+floor_thickness/2]) 
    
 
    // NEW FLOOR
    keyed_floor(size=[stock_width-wall_thickness,stock_height/2-wall_thickness,floor_thickness], key_height=key_height, inset=polarity==1, margin=margin, ambidextrous_keys=true);
        
        
    
    // wall for narrow outer side
    
        
    translate([0,polarity*(stock_height/4-wall_thickness/2),0]) {
    standard_ridge([stock_width,wall_thickness,stock_depth],center=true, handedness = 1);
    }
    
    // wall for inner divider
     translate([0,-polarity*(stock_height/4),0]) {
    standard_ridge([stock_width,wall_thickness,stock_depth],center=true, handedness = -1);
    }
    
    // walls for long outer sides
     translate([stock_width/2-wall_thickness/2,0,0])
    standard_ridge([wall_thickness,stock_height/2,stock_depth],center=true, handedness=-1);
    translate([-(stock_width/2-wall_thickness/2),0,0])
     standard_ridge([wall_thickness,stock_height/2,stock_depth],center=true);
    
    if(polarity==1) {
           four_keys(taller=true); // positive keys
    }
    
    }   
 
    // THE PUMPKINOID
    translate([0,0*-6*scale*polarity,-(stock_depth/2-floor_thickness)])
    rotate([0,90*(1-polarity),0]) intersection() {
    translate([0,0,polarity*stock_depth/2]) cube(center=true,[stock_width,stock_height/2,stock_depth]);
    rotate([0,90,0]) standard_pumpkinoid();
    }
    
    }
    
}

    // (POSITIVE) SPIGOT / SPRUE
    spout_radius = 0.3 * inch;
    //spout_length = stock_height/4;
   
    spout_length = stock_width/4*1.1;
    spout_length = stock_width/2-pumpkin_radius*0.85;
   spout_length = stock_width/2-pumpkin_radius+0.5;

    color("cyan") translate([-stock_width/2+spout_length/2,-(stock_height/4),
    0*-spout_radius*1.5+floor_thickness/2-spout_radius]) rotate([90,0,-90]) cylinder(center=true,h=spout_length, r1=spout_radius,r2=spout_radius*1.5); 

    * color("cyan") translate([0,-(stock_height/4)-(stock_height/4-wall_thickness/2)/2,0]) rotate([90,0,0]) cylinder(center=true,h=spout_length, r1=spout_radius,r2=spout_radius*1.5); 

}
}
}
}

* ambidextrous_pumpkinoid();


union() {
* translate([-stock_width/2,0,0]) rotate([0,0,90]) stock()
* translate([0,0,-stock_depth]) rotate([0,180,0]) translate([-stock_width/2,0,0]) ambidextrous_pumpkinoid();
translate([-stock_width/2,0,0]) ambidextrous_pumpkinoid();
}
